import React from 'react';
import { storiesOf } from '@storybook/react';
import IconSettings from '../../icon-settings';
import { TEXTAREA } from '../../../utilities/constants';
import Textarea from '../';
import Default from '../__examples__/default';
import Disabled from '../__examples__/disabled';
import Error from '../__examples__/error';

storiesOf(TEXTAREA, module)
	.addDecorator((getStory) => (
		<div className="slds-p-around_medium">
			<IconSettings iconPath="/assets/icons">{getStory()}</IconSettings>
		</div>
	))
	.add('Standard', () => (
		<Textarea
			label="Textarea Label"
			name="standard-textarea"
			placeholder="Placeholder Text"
		/>
	))
	.add('Disabled', () => (
		<Textarea
			name="disabled"
			label="Textarea Label"
			disabled
			placeholder="Placeholder Text"
		/>
	))
	.add('Required', () => (
		<Textarea
			aria-describedby="required-1"
			name="required-textarea"
			assistiveText={{
				label: 'Textarea Label',
			}}
			required
			placeholder="Placeholder Text"
		/>
	))
	.add('Error', () => (
		<Textarea
			aria-describedby="error-1"
			name="required-textarea-error"
			label="Textarea Label"
			required
			errorText="Error Message"
			placeholder="Placeholder Text"
		/>
	))
	.add('Docs site Default', () => <Default />)
	.add('Docs site Disabled', () => <Disabled />)
	.add('Docs site Error', () => <Error />);
