"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

var _snapshotHelpers = require("../../../tests/snapshot-helpers");

var _base = _interopRequireDefault(require("../__examples__/base"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-env jest */
test('Radio Group Base DOM Snapshot', function () {
  var domTree = _reactTestRenderer.default.create(_react.default.createElement(_base.default, {
    name: "radioGroup"
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('Radio Group Base HTML Snapshot', function () {
  expect((0, _snapshotHelpers.renderMarkup)(_base.default, {
    name: 'radioGroup'
  })).toMatchSnapshot();
});
test('Radio Group Disabled DOM Snapshot', function () {
  var domTree = _reactTestRenderer.default.create(_react.default.createElement(_base.default, {
    name: "radioGroup",
    disabled: true
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('Radio Group Required DOM Snapshot', function () {
  var domTree = _reactTestRenderer.default.create(_react.default.createElement(_base.default, {
    name: "radioGroup",
    required: true
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('Radio Group Error DOM Snapshot', function () {
  var domTree = _reactTestRenderer.default.create(_react.default.createElement(_base.default, {
    name: "radioGroup",
    errorLabel: "error message",
    errorId: "radioGroupError"
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});